Subject: Re: bug#66117: 30.0.50; `find-buffer-visiting' is slow when opening large number of buffers

From: Stefan Monnier <[email-masked]>
Date: Thu, 14 Dec 2023 14:56:18 -0500

>>> I must say I don't understand the reasoning behind this.
>>> What would it do different from `case-fold-search`?
>> It won't be buffer-local-if-changed, so binding it will not be costly.
>> It also won't be a defcustom, so let-binding it will not step on the
>> user's preferences.
> In my mind, another benefit is that the new variable will not be
> affected by buffer-local values - (let (case-fold-search-override value) ...)
> will be guaranteed to use VALUE everywhere, even if current buffer is
> changed. This will make the case I described in
> https://debbugs.gnu.org/cgi/bugreport.cgi?bug=66117#208 more predictable
> (and, since it is a new variable, will not break any existing code).

But of course, as always it cuts both ways.  E.g. if you do

    (let ((case-fold-search-override t))
      (dolist (buf (buffer-list))
        (when (string-match "foo" buffer-file-name)
          (do-something))))

your `case-fold-search-override` will override all the careful
`case-fold-search` let-bindings used during the execution of `do-something`
which will likely lead to new bugs.

[ Say, if `do-something` ends up calling `syntax-ppss` which ends up
  running `syntax-propertize` which often needs to perform
  case-sensitive searches.  ]

        Stefan